#www.oinvestidor.club


#bibliotecas
# install.packages("rtweet")
# install.packages("wordcloud")
# install.packages("RColorBrewer)
# install.packages("NPL")
# install.packages("tm")
# install.packages("cluster")
# install.packages("fpc")
#install.library(twitteR)
# install.packages("RCurl")
# install.packages("httr")
# install.packages("syuzhet")

install.packages("twitteR", repos = "http://cran.us.r-project.org")
install.packages("RCurl", repos = "http://cran.us.r-project.org")
install.packages("httr", repos = "http://cran.us.r-project.org")
install.packages("syuzhet", repos = "http://cran.us.r-project.org")

#Carregar bibliotecas
library(rtweet)
library(wordcloud)
library(RColorBrewer)
library(RCurl)
library(NPL)
library(tm)
library(cluster)   
library(fpc)
library(RCurl)
library(httr)
library(syuzhet)
library(twitteR)
library(plotly)
library(ggplot2)
library(lubridate)
library(scales)
library(reshape2)
library(dplyr)

# coloque suas chaves do API do TWEETER WWW.APPS.TWEETER.COM
api_key             <- "coloca qui a tua api"
api_secret          <- "coloca aqui a tua api kei"
access_token        <- "coloca aqui o acess toquem"
access_token_secret <- "coloca aqui p acess toquen secret"

setup_twitter_oauth(api_key, api_secret, access_token, access_token_secret)

##########################################################################################
#ANALISANDO AS TENDENCIAS DE UM CERTO PAS

#procurar lista de codigos das tendencias por cidade

trend <- availableTrendLocations()
head(trend)
trend

#procurar tendencia de tweets de uma certa localidade
localidade <- getTrends(1)
localidade



##########################################################################################
#BUSCAR A PALAVRA CHAVE DO TWEET
#Limite de 18.000 tweets a cada 15 minutos conforme as especificaes do tweeter


oinvestidor_tweets <- search_tweets("$GS", n = 18000, include_rts = FALSE,lang = "en")

#visualizaao dos tweets tirados
oinvestidor_tweets %>%
  ts_plot("1 hours") +
  ggplot2::theme_minimal() +
  ggplot2::theme(plot.title = ggplot2::element_text(face = "bold")) +  ggplot2::labs(    x = NULL, y = NULL,
    title = "Frequencia de #oinvestidor Twitter posts",
    subtitle = "Tweets a cada 1 hora",
    caption = "\nSource: Dados coletados da Twitter's REST API via rtweet")

##########################################################################################
#INICIO TEXT MINING 
oinvestidor_text <- oinvestidor_tweets$text


# PRIMEIRA LIMPEZA DE TEXTOS

oinvestidor_tweets$text=gsub("&amp", "", oinvestidor_tweets$text)
oinvestidor_tweets$text = gsub("&amp", "", oinvestidor_tweets$text)
oinvestidor_tweets$text = gsub("(RT|via)((?:\\b\\W*@\\w+)+)", "", oinvestidor_tweets$text)
oinvestidor_tweets$text = gsub("@\\w+", "", oinvestidor_tweets$text)
oinvestidor_tweets$text = gsub("[[:punct:]]", "", oinvestidor_tweets$text)
oinvestidor_tweets$text = gsub("[[:digit:]]", "", oinvestidor_tweets$text)
oinvestidor_tweets$text = gsub("http\\w+", "", oinvestidor_tweets$text)
oinvestidor_tweets$text = gsub("[ \t]{2,}", "", oinvestidor_tweets$text)
oinvestidor_tweets$text = gsub("^\\s+|\\s+$", "", oinvestidor_tweets$text)

oinvestidor_tweets$text <- iconv(oinvestidor_tweets$text, "UTF-8", "ASCII", sub="")

# AQUI VAMOS COLOCAR O CODIGO ONDE VAI LER AS EMOES DOS TWEETS

# EmoES POR CADA TWEET USANDO O DICIONARIO NRC 

emocoes <- get_nrc_sentiment(oinvestidor_tweets$text)
head (emocoes)

barplot(colSums(emocoes),las=2, col = rainbow(10), ylab = 'count', main = 'SENTIMENTOS DOS TWEETS')


###################################################################
# FAZENDO O CLUSTERING E KMEANS ENCONTRAR SENTIDO NA PROCURA

#SEGUNDA LIMPEZA DO TEXTO

#Criando e limpando mais o corpo de texto
oinvestidor_text_corpus <- VCorpus(VectorSource(oinvestidor_text))
oinvestidor_text_corpus <- tm_map(oinvestidor_text_corpus,
                                  content_transformer(function(x) iconv(x, to='UTF-8', sub='byte')))
oinvestidor_text_corpus <- tm_map(oinvestidor_text_corpus, content_transformer(tolower))
oinvestidor_text_corpus <- tm_map(oinvestidor_text_corpus, removePunctuation)
oinvestidor_text_corpus <- tm_map(oinvestidor_text_corpus,removeWords, stopwords("english"))

#Primeira visualizaao
wordcloud(oinvestidor_text_corpus,min.freq=2,max.words=100)
formatacao <- brewer.pal(8,"Dark2")
wordcloud(oinvestidor_text_corpus,min.freq=2,max.words=100, random.order=T, colors=formatacao)


#####
#Limpeza do texto com a Document Term Matrix
oinvestidor_dtm <- DocumentTermMatrix(oinvestidor_text_corpus)   
oinvestidor_dtm

oinvestidor_frequencia <- colSums(as.matrix(oinvestidor_dtm))   
length(oinvestidor_frequencia) 
tail(oinvestidor_frequencia,10)

#Removendo termos esparos
oinvestidor_dtms <- removeSparseTerms(oinvestidor_dtm, 0.98) 
oinvestidor_dtms

oinvestidor_frequencia <- colSums(as.matrix(oinvestidor_dtms))   
length(oinvestidor_frequencia) 

oinvestidor_frequencia <- sort(colSums(as.matrix(oinvestidor_dtms)), decreasing=TRUE) 
oinvestidor_frequencia

#Convertendo a matriz de frequencia em dataframe para o plot
oinvestidor_plot <- data.frame(word=names(oinvestidor_frequencia), freq=oinvestidor_frequencia)  

#Criando o grafico
grafico <- ggplot(subset(oinvestidor_plot, oinvestidor_frequencia>800), aes(x = reorder(word, -freq), y = freq)) +
  geom_bar(stat = "identity") + 
  theme(axis.text.x=element_text(angle=45, hjust=1)) +
  ggtitle("Grafico de barras com os termos mais frequentes") +
  labs(y="Frequencia", x = "Termos")
grafico   

#Removendo palavras especificas e limpando novamente o corpus
oinvestidor_text_corpus <- tm_map(oinvestidor_text_corpus, removeWords, c("tsla","tesla","amp","foodporn"))
oinvestidor_dtms <- removeSparseTerms(DocumentTermMatrix(oinvestidor_text_corpus) , 0.98) 
oinvestidor_dtms

oinvestidor_frequencia <- colSums(as.matrix(oinvestidor_dtms))   
length(oinvestidor_frequencia) 

oinvestidor_frequencia <- sort(colSums(as.matrix(oinvestidor_dtms)), decreasing=TRUE) 
oinvestidor_frequencia

#Convertendo a matriz de frequencia em dataframe para o plot
oinvestidor_plot <- data.frame(word=names(oinvestidor_frequencia), freq=oinvestidor_frequencia)  

#Criando o grafico
grafico <- ggplot(subset(oinvestidor_plot, oinvestidor_frequencia>800), aes(x = reorder(word, -freq), y = freq)) +
  geom_bar(stat = "identity") + 
  theme(axis.text.x=element_text(angle=45, hjust=1)) +
  ggtitle("Grafico de barras com os termos mais frequentes") +
  labs(y="Frequencia", x = "Termos")
grafico   


#Nova nuvem de palavras
wordcloud(names(oinvestidor_frequencia),oinvestidor_frequencia,min.freq=2,max.words=150, random.order=T, colors=formatacao)

#####
#Aplicando um pouco de machine learning - Clustering
oinvestidor_dtms2 <- removeSparseTerms(oinvestidor_dtms, 0.95)
oinvestidor_dtms2

#Clustering 1 - Dendograma
distancia <- dist(t(oinvestidor_dtms2), method="euclidian")   
dendograma <- hclust(d=distancia, method="complete")
plot(dendograma, hang=-1,main = "Dendograma Tweets oinvestidor - Oinvestidor",
     xlab = "Distancia",
     ylab = "Altura")  

#Para ler melhor o Dendograma
groups <- cutree(dendograma, k=5)
rect.hclust(dendograma, k=5, border="red")   

#Clustering 2 - K-Means
kmeans_btc <- kmeans(distancia, 5)   
clusplot(as.matrix(distancia), kmeans_btc$cluster, color=T, shade=T, labels=3, lines=0,
         main = "K-Means Tweets oinvestidor - Oinvestidor",
         xlab = "PC1",
         ylab = "PC2")


